Dim t,m,d,h,wd 
Dim time$(20),set$,name$(16),com$
DIM t1$(7),t2$(7),t3$(7),t4$(7),t5$(7),t6$(7),t7$(7),t8$(7)			' define time variables for setup
DIM t9$(7),t10$(7),t11$(7),t12$(7),t13$(7),t14$(7),t15$(7),t16$(7) 	' define time variables for setup
DIM e1$(71),e2$(71),e3$(71),e4$(71),e5$(71),e6$(71)					' communication event strings
DIM r1,r2,r3,r4,r5,r6,r7,r8,r9,r10,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10 
DIM ptmp1,ptmp2,proto,ppath$(50),pport$(6),t99,oldtime$(7)


name$ = sprintf$("%1A",1)
SYSLOG "Start Barionet scheduler application on "+name$ + " v1.00", 1
	
'=================================Read setup==================================================	
com$= "STP:400"
OPEN com$ as 1
READ 1, set$
CLOSE 1
t1$=MID$(set$,1,6)	 							' 400 time for scheduler 1
r1= MIDGET(set$,8,1) 							' 407 output/relay register for IO action1
v1= MIDGET(set$,9,2) 							' 408 value for action1 register
t2$=MID$(set$,11,6)	 							' 410 time for scheduler 2
r2= MIDGET(set$,18,1) 							' 417 output/relay register for IO action2
v2= MIDGET(set$,19,2) 							' 418 value for action2 register
t3$=MID$(set$,21,6)	 							' 420 time for scheduler 3
r3= MIDGET(set$,28,1) 							' 427 output/relay register for IO action3
v3= MIDGET(set$,29,2) 							' 428 value for action3 register
t4$=MID$(set$,31,6)	 							' 430 time for scheduler 4
r4= MIDGET(set$,38,1) 							' 437 output/relay register for IO action4
v4= MIDGET(set$,39,2) 							' 438 value for action4 register
t5$=MID$(set$,41,6)	 							' 440 time for scheduler 5
r5= MIDGET(set$,48,1)							' 447 output/relay register for IO action5
v5= MIDGET(set$,49,2)							' 448 value for action5 register
t6$=MID$(set$,51,6)								' 450 time for scheduler 6
r6= MIDGET(set$,58,1)							' 457 output/relay register for IO action6
v6= MIDGET(set$,59,2)							' 458 value for action6 register
t7$=MID$(set$,61,6)								' 460 time for scheduler 7
r7= MIDGET(set$,68,1)							' 467 output/relay register for IO action7
v7= MIDGET(set$,69,2)							' 468 value for action7 register
t8$=MID$(set$,71,6)								' 470 time for scheduler 8
r8= MIDGET(set$,78,1)							' 477 output/relay register for IO action8
v8= MIDGET(set$,79,2)							' 478 value for action8 register
t9$=MID$(set$,81,6)								' 480 time for scheduler 9
r9= MIDGET(set$,88,1)							' 487 output/relay register for IO action9
v9= MIDGET(set$,89,2)							' 488 value for action9 register
t10$=MID$(set$,91,6)							' 490 time for scheduler 10
r10= MIDGET(set$,98,1)							' 497 output/relay register for IO action10
v10= MIDGET(set$,99,2)							' 498 value for action10 register

com$= "STP:525"
OPEN com$ as 1
READ 1, set$
CLOSE 1
t11$=MID$(set$,1,6)								' 525 time for scheduler 11
e1$= MID$(set$,9,70)							' 533 string for communication event1
t12$=MID$(set$,81,6)							' 605 time for scheduler 12
e2$= MID$(set$,89,70)							' 613 string for communication event2
t13$=MID$(set$,161,6)							' 685 time for scheduler 13
e3$= MID$(set$,169,70)							' 693 string for communication event3

com$= "STP:765"
OPEN com$ as 1
READ 1, set$
CLOSE 1
t14$=MID$(set$,1,6)								' 765 time for scheduler 14
e4$= MID$(set$,9,70)							' 773 string for communication event4
t15$=MID$(set$,81,6)							' 845 time for scheduler 15
e5$= MID$(set$,89,70)							' 853 string for communication event5
t16$=MID$(set$,161,6)							' 925 time for scheduler 16
e6$= MID$(set$,169,70)							' 933 string for communication event6
set$=" "
'----------------------------------------------------------------------------------------------------

'================================prepare time for european summer-/winter time change================
10 
	t=_DTS_ 						' get time in seconds ever since .. 
	time$=SPRINTF$("%49t",t)				' get time value from argument, plus weekday as last digit 
	m=val(mid$(time$,3,2))					' get month         
	d=val(mid$(time$,5,2))					' get date 
	h=val(mid$(time$,7,2))					' get hour 
	wd=val(mid$(time$,13,1))				' get weekday
'----------------------------------------------------------------------------------------------------

'====================scheduling - compare time strings===============================================
20     time$=SPRINTF$("%17t",t)					' now use eventually corrected time to generate string
       IF mid$(time$,7,6)=oldtime$ THEN				' checks that each operation is only executed one time per second
		 DELAY 70					' if equal, wait and check again
'		 SYSLOG "looping time",8				
		 GOTO 10
       ENDIF
       oldtime$=mid$(time$,7,6)
       IF mid$(time$,7,6)=t1$ THEN IOCTL r1,v1			' scheduling action 1
       IF mid$(time$,7,6)=t2$ THEN IOCTL r2,v2			' scheduling action 2
       IF mid$(time$,7,6)=t3$ THEN IOCTL r3,v3			' scheduling action 3
       IF mid$(time$,7,6)=t4$ THEN IOCTL r4,v4			' scheduling action 4
       IF mid$(time$,7,6)=t5$ THEN IOCTL r5,v5			' scheduling action 5
       IF mid$(time$,7,6)=t6$ THEN IOCTL r6,v6			' scheduling action 6
       IF mid$(time$,7,6)=t7$ THEN IOCTL r7,v7			' scheduling action 7
       IF mid$(time$,7,6)=t8$ THEN IOCTL r8,v8			' scheduling action 8
       IF mid$(time$,7,6)=t9$ THEN IOCTL r9,v9			' scheduling action 9
       IF mid$(time$,7,6)=t10$ THEN IOCTL r10,v10		' scheduling action 10
       IF mid$(time$,7,6)=t11$ THEN set$=e1$ : GOSUB 100	' scheduling event 1
       IF mid$(time$,7,6)=t12$ THEN set$=e2$ : GOSUB 100	' scheduling event 2
       IF mid$(time$,7,6)=t13$ THEN set$=e3$ : GOSUB 100	' scheduling event 3
       IF mid$(time$,7,6)=t14$ THEN set$=e4$ : GOSUB 100	' scheduling event 4
       IF mid$(time$,7,6)=t15$ THEN set$=e5$ : GOSUB 100	' scheduling event 5
       IF mid$(time$,7,6)=t16$ THEN set$=e6$ : GOSUB 100	' scheduling event 6
       DELAY 100
       GOTO 10
END
'-----------------------------------------------------------------------------------------------

'=========================execution of the communication event==================================
100 	'parse URL
proto=99
IF MID$(set$,1,6) ="udp://" THEN
   proto=1
   IF MID$(set$,7,1)="(" THEN				' check for "(" in command string
     temp=INSTR(1,set$,")")-8
     dlay=VAL(MID$(set$,8,temp))			' extract delay value 
     set$=MID$(set$,temp+9)				' cut protocol info, without protocol type and delays
     ELSE
       set$=MID$(set$,7)				' cut protocol info
   ENDIF
ENDIF
IF MID$(set$,1,6) ="tcp://" THEN
   proto=3
   IF MID$(set$,7,1)="(" THEN				' check for "(" in command string
     temp=INSTR(1,set$,")")-8
     dlay=VAL(MID$(set$,8,temp))			' extract delay value 
     set$=MID$(set$,temp+9)				' cut protocol info, without protocol type and delays
     ELSE
       set$=MID$(set$,7)				' cut protocol info
   ENDIF
ENDIF
'	ptmp1=INSTR(1,set$,"http://")
IF MID$(set$,1,7) ="http://" THEN
   proto=0
   IF MID$(set$,8,1) ="(" THEN
     temp=INSTR(1,set$,")")-9
     dlay=VAL(MID$(set$,9,temp))
     set$=MID$(set$,temp+10)				' cut protocol info, without protocol type and delays
     ELSE
       set$=MID$(set$,8)				' cut protocol info
   ENDIF
ENDIF
IF MID$(set$,1,7) ="com1://" THEN
   proto=2
   IF MID$(set$,8,1) ="(" THEN
     temp=INSTR(1,set$,")")-9
'     dlay=VAL(MID$(set$,9,temp))
     set$=MID$(set$,temp+10)				' cut protocol info, without protocol type and delays
     ELSE
       set$=MID$(set$,8)				' cut protocol info
   ENDIF
ENDIF
IF LEN(set$)<1 THEN
   proto=4						' empty config field
   SYSLOG "empty config field",3
   RETURN
ENDIF

IF proto=99 THEN SYSLOG "Wrong protocol in URL" : RETURN
IF proto=2 THEN GOSUB 130 : RETURN			' If serial protocol

ptmp1=INSTR(1,set$,":")
ptmp2=INSTR(1,set$,"/")
IF ptmp2=0 THEN ptmp2=LEN(set$)-1
IF AND(ptmp1>0,ptmp1<ptmp2) THEN
	pport$=MID$(set$,ptmp1+1,ptmp2-ptmp1-1)
	IF OR(proto=1,proto=3) THEN ppath$=MID$(set$,ptmp2+1)
	IF proto=0 THEN ppath$=MID$(set$,ptmp2)
	set$=MID$(set$,1,ptmp1-1)
	ELSE
		IF proto = 0 THEN
			pport$="80"
		        ELSE
			  SYSLOG "Error: Port must be specified for UDP protocol.",1
			  RETURN
		ENDIF
		IF proto=0 THEN ppath$=MID$(set$,ptmp2)
                IF OR(proto=1,proto=3) THEN ppath$=MID$(set$,ptmp2+1)
		set$=MID$(set$,1,ptmp2-1)
ENDIF
'send request
IF proto=0 THEN
	SYSLOG "Opening TCP:"+set$+":"+pport$,3
	OPEN "TCP:"+set$+":"+pport$ as 0
	t2=_TMR_(0)
	110   IF CONNECTED(0)=0 THEN			' wait for the remote server
		IF _TMR_(0)-t2>(1000+dlay) THEN 
			SYSLOG "http server does not respond"
			IF MEDIATYPE(0)<>0 THEN CLOSE 0
			RETURN
		ENDIF
		GOTO 110
	      ENDIF
	      pos=INSTR(1,ppath$,"#26")			' allows to use a "&" in the event string 
	      IF pos THEN
		s1$=MID$(ppath$,1,pos-1)
		s2$=MID$(ppath$,pos+3)
		ppath$=s1$+"&"+s2$
	      ENDIF
	      SYSLOG "sending GET..."+ppath$,2
	      buf$=""
	      WRITE 0, "GET "+ppath$+" HTTP/1.0\r\n\r\n"     
	      DELAY 50
	      READ 0,buf$,0
              SYSLOG "HTTP Response : "+buf$
  	      CLOSE 0
ENDIF
IF proto=1 THEN
	OPEN "UDP:"+set$+":"+pport$ AS 0
	pos=INSTR(1,ppath$,"#26")			' allows to use a "&" in the event string 
	IF pos THEN
	   s1$=MID$(ppath$,1,pos-1)
	   s2$=MID$(ppath$,pos+3)
	   ppath$=s1$+"&"+s2$
	ENDIF
	SYSLOG "0 | "+ ppath$+"| 0 |"+ set$+" | "+ pport$,3
        IF dlay>0 THEN WRITE 0, "",0, set$, val(pport$) : DELAY dlay
	ppath$=ppath$+CHR$(13)+CHR$(10)
	buf$=""
	WRITE 0, ppath$,0, set$, val(pport$)
	DELAY 50
	READ 0,buf$,0
        SYSLOG "UDP Response : "+buf$,2
	CLOSE 0
		
ENDIF
IF proto=3 THEN
	SYSLOG "Opening TCP:"+set$+":"+pport$,3
	OPEN "TCP:"+set$+":"+pport$ as 0
	t2=_TMR_(0)
	120   IF CONNECTED(0)=0 THEN			' wait for the remote server
		IF _TMR_(0)-t2>(1000+dlay) THEN 
			SYSLOG "TCP server does not respond"
			IF MEDIATYPE(0)<>0 THEN CLOSE 0
			RETURN
		ENDIF
		GOTO 120
	      ENDIF
	      pos=INSTR(1,ppath$,"#26")			' allows to use a "&" in the event string 
	      IF pos THEN
		s1$=MID$(ppath$,1,pos-1)
		s2$=MID$(ppath$,pos+3)
		ppath$=s1$+"&"+s2$
	      ENDIF
	      SYSLOG "sending TCP message: "+ppath$,2
	      buf$=""
	      WRITE 0, ppath$+CHR$(13)+CHR$(10)     
	      DELAY 50
	      READ 0,buf$,0
              SYSLOG "TCP Response : "+buf$
  	      CLOSE 0
ENDIF
ptmp1=0
set$=""
dlay=0
RETURN

130  OPEN "COM::1" AS 0
SYSLOG "0 | Write serial message ",2
pos=INSTR(1,set$,"#26")					' allows to use a "&" in the event string 
IF pos THEN
   s1$=MID$(set$,1,pos-1)
   s2$=MID$(set$,pos+3,b)
   set$=s1$+"&"+s2$
ENDIF
set$=set$+CHR$(13)+CHR$(10)
mlen=LEN(set$)
buf$=""
WRITE 0, set$, mlen
DELAY 50
READ 0,buf$,1
SYSLOG "Serial Response : "+buf$,2
CLOSE 0

ptmp1=0
set$=""
RETURN

